<template>
  <div v-if="models === null">Waiting...</div>
  <apexchart
    v-else
    :options="chartOptions"
    :series="series"
    type="scatter"
    class="w-full"
  />
</template>

<script>
import { mapState, mapActions } from "vuex";

export default {
  computed: {
    ...mapState(["models", "bestModel", "selectedModel"]),

    chartOptions() {
      return {
        chart: {
          id: "prognostic_model__view",
          type: "scatter",
          toolbar: {
            show: true,
            tools: {
              zoom: true,
              zoomin: true,
              zoomout: true
            }
          },
          zoom: {
            enabled: true,
            type: "x",
            zoomedArea: {
              fill: {
                color: "#00acac",
                opacity: 0.4
              },
              stroke: {
                color: "#00acac",
                opacity: 0.4,
                width: 1
              }
            }
          },
          events: {
            dataPointSelection: (event, context, config) => {
              if (config.seriesIndex === 0) return;
              if (config.seriesIndex === 1) {
                this.changeSelectedModel(this.bestModel);
                return;
              }
              this.changeSelectedModel(config.dataPointIndex);
            }
          }
        },
        tooltip: {
          x: {
            formatter: value => {
              const index = this.models.findIndex(m => m[0] === value);
              return `Model ${index}`;
            }
          },
          y: {
            formatter: value => {
              return `accuracy = ${value.toFixed(3)}`;
            }
          }
        },
        colors: ["#ff690a", "#ff0a25", "#00acac"],
        xaxis: {
          type: "numeric",
          labels: {
            formatter(value) {
              return Math.round(value * 1000) / 1000;
            }
          },
          tooltip: {
            enabled: true,
            formatter: value => value
          },
          title: {
            text: "Attribute Relevance Threshold",
            offsetY: 10,
            style: {
              cssClass: "f-subtitle"
            }
          },
          tickAmount: 6
        },
        yaxis: {
          type: "numeric",
          labels: {
            formatter(value) {
              return Math.round(value * 10) / 10;
            }
          },
          tooltip: {
            enabled: false
          },
          title: {
            text: "Accuracy",
            offsetX: -10,
            style: {
              cssClass: "f-subtitle"
            }
          },
          forceNiceScale: false,
          min: 0,
          max: 1
        },
        legend: {
          height: 30,
          offsetX: 10,
          offsetY: -10
        }
      };
    },
    series() {
      return [
        {
          name: "Selected",
          data: [this.models[this.selectedModel]]
        },
        {
          name: "Best Model",
          data: [this.models[this.bestModel]]
        },
        {
          name: "Models",
          data: this.models
        }
      ];
    }
  },
  methods: {
    ...mapActions(["changeSelectedModel"])
  }
};
</script>
